CREATE OR REPLACE PROCEDURE SP_MODIFICACIO_EST3
IS
/******************************************************************************
   Nom:                 SP_MODIFICACIO_EST3
   Propsit:            Actualitza la taula estadstica EST3_TEMPS_MIG. 
                        La informaci actualitzada correspon al temps mig de 
						registre per pas.
                   
   Parmetres entrada:  sense parmetres.

   Retorna:             'OK' si l'execuci ha finalitzat amb xit
                        'ERROR: tipus d'error' si ha fracassat
******************************************************************************/
paramsEntrada	VARCHAR2(500);
RSP				VARCHAR2 (500);
err_msg			VARCHAR2 (500);

BEGIN

paramsEntrada:= 'sense parmetres';

--Esborra les dades de la taula EST3
DELETE FROM EST3_TEMPS_MIG;

--Calcula el valor mitj de durada dels registres per a cada pas
INSERT INTO EST3_TEMPS_MIG(pais, mPais) SELECT *
	FROM (SELECT pais, ROUND(AVG(durada), 4)
			FROM REGISTRE
			WHERE durada IS NOT NULL
			GROUP BY pais
			ORDER BY 2 DESC);

-- Finalitza amb xit
RSP:= 'OK';
SP_ALTA_LOGS(to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'), 'SP_MODIFICACIO_EST3', paramsEntrada, 'RSP: '||RSP);

COMMIT;

EXCEPTION
	
	WHEN OTHERS THEN
		ROLLBACK;
		err_msg := SUBSTR (SQLERRM, 1, 200);
		RSP:= 'ERROR EST3: ' || err_msg;
		SP_ALTA_LOGS(to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'), 'SP_MODIFICACIO_EST3', paramsEntrada, 'RSP: '||RSP);
		DBMS_OUTPUT.PUT_LINE(RSP);

END SP_MODIFICACIO_EST3;