CREATE OR REPLACE PROCEDURE SP_MODIFICACIO_EST1
IS
/******************************************************************************
   Nom:                 SP_MODIFICACIO_EST1
   Propsit:            Actualitza la taula estadstica EST1_PROD_COST. 
                        La informaci actualitzada correspon al producte que ha 
                        costat ms registrar en euros ().
                   
   Parmetres entrada:  sense parmetres.

   Retorna:             'OK' si l'execuci ha finalitzat amb xit
                        'ERROR: tipus d'error' si ha fracassat
******************************************************************************/
paramsEntrada	VARCHAR2(500);
RSP				VARCHAR2 (500);
err_msg			VARCHAR2 (500);

BEGIN

paramsEntrada:= 'sense parmetres';

--Esborra les dades de la taula EST1
DELETE FROM EST1_PROD_COST;

--Introdueix els productes que ms costa registrar a la taula:
INSERT INTO EST1_PROD_COST(producte, cost) SELECT *
	FROM (SELECT producte, MAX(quantitat)
			FROM COST
			GROUP BY producte
			ORDER BY 2 DESC)
	WHERE ROWNUM <= 10;

-- Finalitza amb xit
RSP:= 'OK';
SP_ALTA_LOGS(to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'), 'SP_MODIFICACIO_EST1', paramsEntrada, 'RSP: '||RSP);

COMMIT;

EXCEPTION
	
	WHEN OTHERS THEN
		ROLLBACK;
		err_msg := SUBSTR (SQLERRM, 1, 200);
		RSP:= 'ERROR EST1: ' || err_msg;
		SP_ALTA_LOGS(to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'), 'SP_MODIFICACIO_EST1', paramsEntrada, 'RSP: '||RSP);
		DBMS_OUTPUT.PUT_LINE(RSP);

END SP_MODIFICACIO_EST1;