CREATE OR REPLACE PROCEDURE SP_MODIFICACIO_EST2
IS
/******************************************************************************
   Nom:                 SP_MODIFICACIO_EST2
   Propsit:            Actualitza la taula estadstica EST2_PAISOS_TRAM_LENT. 
                        La informaci actualitzada correspon als pasos a on 
						els trmits sn ms lents.
                   
   Parmetres entrada:  sense parmetres.

   Retorna:             'OK' si l'execuci ha finalitzat amb xit
                        'ERROR: tipus d'error' si ha fracassat
******************************************************************************/
paramsEntrada	VARCHAR2(500);
RSP				VARCHAR2 (500);
err_msg			VARCHAR2 (500);

BEGIN

paramsEntrada:= 'sense parmetres';

--Esborra les dades de la taula EST2
DELETE FROM EST2_PAISOS_TRAM_LENT;

--Introdueix els pasos a on els trmits sn ms lents a la taula:
INSERT INTO EST2_PAISOS_TRAM_LENT(pais, duradaTramit) SELECT *
	FROM (SELECT pais, MAX(durada)
			FROM REGISTRE
			WHERE durada IS NOT NULL
			GROUP BY pais
			ORDER BY 2 DESC)
	WHERE ROWNUM <= 10;

-- Finalitza amb xit
RSP:= 'OK';
SP_ALTA_LOGS(to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'), 'SP_MODIFICACIO_EST2', paramsEntrada, 'RSP: '||RSP);

COMMIT;

EXCEPTION
	
	WHEN OTHERS THEN
		ROLLBACK;
		err_msg := SUBSTR (SQLERRM, 1, 200);
		RSP:= 'ERROR EST2: ' || err_msg;
		SP_ALTA_LOGS(to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'), 'SP_MODIFICACIO_EST2', paramsEntrada, 'RSP: '||RSP);
		DBMS_OUTPUT.PUT_LINE(RSP);

END SP_MODIFICACIO_EST2;