SET SERVEROUTPUT ON;
SPOOL PROVES_ABM.log
SET echo ON

--FORMAT DE LA DATA
ALTER SESSION 
SET NLS_DATE_FORMAT = 'DD/MM/YYYY HH24:MI:SS';


/*--------------------------------------------------------------------------------------------*
 *											PROVES ABM										  *
 *--------------------------------------------------------------------------------------------*/
/
/

--MARCA
DECLARE
	RSP VARCHAR2(500);
BEGIN
	--ALTA CORRECTA D'UNA NOVA MARCA
	SP_ALTA_MARCA('Givenchy', RSP);
	DBMS_OUTPUT.PUT_LINE(RSP); 
   
	--ALTA D'UNA MARCA QUE JA EXISTEIX
	SP_ALTA_MARCA('Artdeco', RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);
   
	--ALTA AMB VALORS NULS
	SP_ALTA_MARCA(null, RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);
   
	--MODIFICACIO CORRECTA D'UNA MARCA QUE JA EXISTEIX
	SP_MODIFICACIO_MARCA(2,'Lancome', RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);  
   
	--MODIFICACIO QUE DUPLICA UNA ALTRA MARCA
	SP_MODIFICACIO_MARCA(5, 'Avon', RSP);
	DBMS_OUTPUT.PUT_LINE(RSP); 
   
	--MODIFICACIO AMB VALORS NULS
	SP_MODIFICACIO_MARCA(8, null, RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);
  
	--BAIXA CORRECTA D'UNA MARCA
	SP_BAIXA_MARCA(7, RSP );
	DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

--ENVAS
DECLARE
	RSP VARCHAR2(500);
BEGIN
	--ALTA CORRECTA D'UN NOU ENVAS
	SP_ALTA_ENVAS('Cautx', RSP);
	DBMS_OUTPUT.PUT_LINE(RSP); 
   
	--ALTA D'UN ENVAS QUE JA EXISTEIX
	SP_ALTA_ENVAS('Plstic', RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);
   
	--ALTA AMB VALORS NULS
	SP_ALTA_ENVAS(null, RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);
   
	--MODIFICACIO CORRECTA D'UN ENVAS QUE JA EXISTEIX
	SP_MODIFICACIO_ENVAS(2,'Fusta', RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);  
   
	--MODIFICACIO QUE DUPLICA UN ALTRE ENVAS
	SP_MODIFICACIO_ENVAS(4, 'Metall', RSP);
	DBMS_OUTPUT.PUT_LINE(RSP); 
   
	--MODIFICACIO AMB VALORS NULS
	SP_MODIFICACIO_ENVAS(2, null, RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);
  
	--BAIXA CORRECTA D'UN ENVAS
	SP_BAIXA_ENVAS(3, RSP );
	DBMS_OUTPUT.PUT_LINE(RSP); 
END;
/

--FORMAT
DECLARE
   RSP VARCHAR2(500);
BEGIN
	--ALTA CORRECTA D'UN NOU FORMAT
	SP_ALTA_FORMAT(2, '1000 ml', RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);
   
	--ALTA AMB UN ENVAS QUE NO EXISTEIX
	SP_ALTA_FORMAT(10, '400 ml', RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);
   
	--ALTA AMB VALORS NULS
	SP_ALTA_FORMAT(1, null, RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);
   
	--MODIFICACIO CORRECTA D'UN FORMAT QUE JA EXISTEIX
	SP_MODIFICACIO_FORMAT(1, 1, '500 ml', RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);  

	--MODIFICACIO D'UN FORMAT QUE NO EXISTEIX
	SP_MODIFICACIO_FORMAT(30, 3, '1000 ml', RSP);
	DBMS_OUTPUT.PUT_LINE(RSP); 
   
	--MODIFICACIO AMB VALORS NULS
	SP_MODIFICACIO_FORMAT(4, 3, null, RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);
	
	--MODIFICACIO AMB UN ENVAS QUE NO EXISTEIX
	SP_MODIFICACIO_FORMAT(4, 10, '400 ml', RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);
  
	--BAIXA CORRECTA D'UN FORMAT
	SP_BAIXA_FORMAT(8, RSP );
	DBMS_OUTPUT.PUT_LINE(RSP);

	--BAIXA D'UN FORMAT QUE NO EXISTEIX
	SP_BAIXA_FORMAT(47, RSP );
	DBMS_OUTPUT.PUT_LINE(RSP); 
END;
/

--PRESENTACIO
DECLARE
	RSP VARCHAR2(500);
BEGIN
	--ALTA CORRECTA D'UNA NOVA PRESENTACIO
	SP_ALTA_PRESENTACIO('Caixa de plstic', RSP);
	DBMS_OUTPUT.PUT_LINE(RSP); 
   
	--ALTA D'UNA PRESENTACIO QUE JA EXISTEIX
	SP_ALTA_PRESENTACIO('Caixa', RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);
   
	--ALTA AMB VALORS NULS
	SP_ALTA_PRESENTACIO(null, RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);
   
	--MODIFICACIO CORRECTA D'UNA PRESENTACIO QUE JA EXISTEIX
	SP_MODIFICACIO_PRESENTACIO(2,'Caixa de fusta', RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);  
   
	--MODIFICACIO QUE DUPLICA UNA ALTRA PRESENTACIO
	SP_MODIFICACIO_PRESENTACIO(4, 'Bossa', RSP);
	DBMS_OUTPUT.PUT_LINE(RSP); 
   
	--MODIFICACIO AMB VALORS NULS
	SP_MODIFICACIO_PRESENTACIO(2, null, RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);
  
	--BAIXA CORRECTA D'UNA PRESENTACIO
	SP_BAIXA_PRESENTACIO(4, RSP );
	DBMS_OUTPUT.PUT_LINE(RSP); 
END;
/

--RESPOSTA
DECLARE
	RSP VARCHAR2(500);
BEGIN
	--ALTA D'UNA RESPOSTA QUE JA EXISTEIX
	SP_ALTA_RESPOSTA('SI', 'REGISTRAT', RSP);
	DBMS_OUTPUT.PUT_LINE(RSP); 
   
	--ALTA AMB VALORS NULS
	SP_ALTA_RESPOSTA('SI', null, RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);
	
	--ALTES INCORRECTES DE NOVES RESPOSTES
	SP_ALTA_RESPOSTA('SI', 'NO REGISTRAT', RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);
	SP_ALTA_RESPOSTA('SI', 'INCOMPLET', RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);
	SP_ALTA_RESPOSTA('NO', 'REGISTRAT', RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

--MONEDA
DECLARE
   RSP VARCHAR2(500);
BEGIN
	--ALTA CORRECTA D'UNA NOVA MONEDA
	SP_ALTA_MONEDA('Real', 0.38, RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);
   
	--ALTA AMB UNA QUANTITAT NEGATIVA
	SP_ALTA_MONEDA('Guaran', -1.18, RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);
   
	--ALTA AMB VALORS NULS
	SP_ALTA_MONEDA(null, 2.06, RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);
   
	--MODIFICACIO CORRECTA D'UNA MONEDA
	SP_MODIFICACIO_MONEDA(5, 'Peso argent', 0.16, RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);  

	--MODIFICACIO AMB UNA QUANTITAT NEGATIVA
	SP_MODIFICACIO_MONEDA(2, 'Lliura esterlina', -1.18, RSP);
	DBMS_OUTPUT.PUT_LINE(RSP); 
  
	--BAIXA CORRECTA D'UNA MONEDA
	SP_BAIXA_MONEDA(8, RSP );
	DBMS_OUTPUT.PUT_LINE(RSP);

	--BAIXA D'UNA MONEDA QUE NO EXISTEIX
	SP_BAIXA_MONEDA(27, RSP );
	DBMS_OUTPUT.PUT_LINE(RSP); 
END;
/

--CONTINENT
DECLARE
   RSP VARCHAR2(500);
BEGIN
	--ALTA AMB VALORS NULS
	SP_ALTA_CONTINENT(null, RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);
   
	--ALTA D'UN CONTINENT QUE JA EXISTEIX
	SP_ALTA_CONTINENT('Antrtida', RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);
END;
/
	
--PAIS
DECLARE
   RSP VARCHAR2(500);
BEGIN
	--ALTA AMB VALORS NULS
	SP_ALTA_PAIS(null, 5, 1, RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);
   
	--ALTA D'UN PAIS QUE JA EXISTEIX
	SP_ALTA_PAIS('Catalunya', 5, 1, RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);
	
	--ALTA AMB UN CONTINENT QUE NO EXISTEIX
	SP_ALTA_PAIS('Egipte', 10, 1, RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

--DISTRIBUIDOR
DECLARE
   RSP VARCHAR2(500);
BEGIN
	--ALTA CORRECTA D'UN NOU DISTRIBUIDOR
	SP_ALTA_DISTRIBUIDOR('South East Company', 10, 'SI', RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);
	
	--ALTA AMB UN PAIS QUE NO EXISTEIX
	SP_ALTA_DISTRIBUIDOR('WorldWide Supply Group', 20, 'NO', RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);
   
	--ALTA AMB VALORS INCORRECTES
	SP_ALTA_DISTRIBUIDOR('WorldWide Supply Group', 10, '??', RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);
	
	--MODIFICACIO CORRECTA D'UN DISTRIBUIDOR QUE JA EXISTEIX
	SP_MODIFICACIO_DISTRIBUIDOR(1,'Catalunya Export', 1, 'SI', RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);  
   
	--MODIFICACIO QUE DUPLICA UN ALTRE DISTRIBUIDOR
	SP_MODIFICACIO_DISTRIBUIDOR(2,'Catalunya Export', 1, 'NO', RSP);
	DBMS_OUTPUT.PUT_LINE(RSP); 
   
	--MODIFICACIO AMB VALORS NULS
	SP_MODIFICACIO_DISTRIBUIDOR(1,'Catalunya Export', null, 'SI', RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);
  
	--BAIXA CORRECTA D'UN DISTRIBUIDOR
	SP_BAIXA_DISTRIBUIDOR(4, RSP );
	DBMS_OUTPUT.PUT_LINE(RSP);

	--BAIXA D'UN DISTRIBUIDOR QUE NO EXISTEIX
	SP_BAIXA_DISTRIBUIDOR(45, RSP );
	DBMS_OUTPUT.PUT_LINE(RSP); 
END;
/	

--PRODUCTE
DECLARE
   RSP VARCHAR2(500);
BEGIN
	--ALTA CORRECTA D'UN NOU PRODUCTE
	SP_ALTA_PRODUCTE('Eau du pear', 'x3y7 + h8i2', 3, 4, 3, 11, 9, RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);
	
	--ALTA AMB UN FORMAT QUE NO EXISTEIX
	SP_ALTA_PRODUCTE('Colgate+', 'x6y1 + h7i5', 20, 4, 3, 11, 9, RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);
   
	--ALTA D'UN PRODUCTE EXISTENT
	SP_ALTA_PRODUCTE('Miele Millefiori', 'x5y9 + h2i1', 3, 4, 3, 11, 9, RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

--REGISTRE
DECLARE
   RSP VARCHAR2(500);
BEGIN
	--BAIXES CORRECTES DE REGISTRES
	SP_BAIXA_REGISTRE(1, RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);
	SP_BAIXA_REGISTRE(7, RSP);
	DBMS_OUTPUT.PUT_LINE(RSP);
	SP_BAIXA_REGISTRE(10, RSP);
	DBMS_OUTPUT.PUT_LINE(RSP); 
END;
/

--TAULA PRODUCTE
SELECT * FROM PRODUCTE;
/

--TAULA REGISTRE
SELECT * FROM REGISTRE ORDER BY 1;
/



/*--------------------------------------------------------------------------------------------*
 *											TAULA LOGS										  *
 *--------------------------------------------------------------------------------------------*/
/
/

SELECT * FROM LOGS ORDER BY 1;
/

SPOOL OFF
EXIT
